#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Mon Apr  4 11:23:12 2011

import wx
import wx.grid
import notif
import element
# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame, notif.Notifier, notif.Notifiable):
    def __init__(self,project, *args, **kwds):
	notif.Notifier.__init__(self)
	notif.Notifiable.__init__(self)
	self.project = project
	self.project.addNotif(self)
	
	
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.button_1 = wx.Button(self, -1, "Create Elem")
        self.button_2 = wx.Button(self, -1, "Exemple")
        self.button_3 = wx.Button(self, -1, "Clear")
        self.button_4 = wx.Button(self, -1, "Connect")
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.combo_box_2 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.combo_box_3 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.combo_box_4 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.button_8 = wx.Button(self, -1, "Remove Element")
        self.button_9 = wx.Button(self, -1, "Deconnect")
        self.button_10 = wx.Button(self, -1, "Refresh")
        self.button_11 = wx.Button(self, -1, "PropertyGrid")
        self.button_5 = wx.Button(self, -1, "button_5")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.OnElem, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.OnExemple, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.OnClear, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.OnConnect, self.button_4)
        self.Bind(wx.EVT_COMBOBOX, self.OnCombo1, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.OnCombo2, self.combo_box_2)
        self.Bind(wx.EVT_COMBOBOX, self.OnCombo3, self.combo_box_3)
        self.Bind(wx.EVT_COMBOBOX, self.OnCombo4, self.combo_box_4)
        self.Bind(wx.EVT_BUTTON, self.OnRmElem, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.OnDeconnect, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.OnRefresh, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.OnPropertyGrid, self.button_11)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("frame_1")
        self.SetSize((700, 545))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_1 = wx.GridSizer(6, 2, 0, 0)
        grid_sizer_1.Add(self.button_1, 0, 0, 0)
        grid_sizer_1.Add(self.button_2, 0, 0, 0)
        grid_sizer_1.Add(self.button_3, 0, 0, 0)
        grid_sizer_1.Add(self.button_4, 0, 0, 0)
        grid_sizer_1.Add(self.combo_box_1, 0, 0, 0)
        grid_sizer_1.Add(self.combo_box_2, 0, 0, 0)
        grid_sizer_1.Add(self.combo_box_3, 0, 0, 0)
        grid_sizer_1.Add(self.combo_box_4, 0, 0, 0)
        grid_sizer_1.Add(self.button_8, 0, 0, 0)
        grid_sizer_1.Add(self.button_9, 0, 0, 0)
        grid_sizer_1.Add(self.button_10, 0, 0, 0)
        grid_sizer_1.Add(self.button_11, 0, 0, 0)
        sizer_1.Add(grid_sizer_1, 1, wx.EXPAND, 0)
        sizer_1.Add(self.button_5, 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.SetSizeHints(self)
        self.Layout()
        # self.Centre() #bug sous ubuntu 11.04
        # end wxGlade


	

    def OnCreateElem(self, kind, pos):
	elem = self.project.createElem(kind,pos)
	self.doNotify()
	return elem

    def OnElem(self, event): # wxGlade: MyFrame.<event_handler>
	dlg = wx.TextEntryDialog(self, 'Enter kind','Element kind')
        dlg.SetValue(" ")
        if dlg.ShowModal() == wx.ID_OK:
		kind = dlg.GetValue()
        dlg.Destroy()

	dlg = wx.TextEntryDialog(self, 'Enter X','Element position')
        dlg.SetValue(" ")
	x_pos = None
        if dlg.ShowModal() == wx.ID_OK:
		x_pos = dlg.GetValue()
        dlg.Destroy()

	dlg = wx.TextEntryDialog(self, 'Enter Y','Element position')
        dlg.SetValue(" ")
        if dlg.ShowModal() == wx.ID_OK:
		y_pos = dlg.GetValue()
        dlg.Destroy()
	pos = (int(x_pos),int(y_pos))

	if kind[0] == 'S':
		elem = self.OnCreateElem(element.State,pos)
	elif kind[0] == 'T':
		elem = self.OnCreateElem(element.Transfo,pos)
	elif kind[0] == 'E':
		elem = self.OnCreateElem(element.Element,pos)
	else:
		print("in minigui : Erreur with kind")
	return elem
	self.doNotify()

    def OnExemple(self, event): # wxGlade: MyFrame.<event_handler>
	# cree et connecte 4 etats et 4 Transformations
	
        elem1 = self.OnCreateElem(element.Pump,(0,0))
	State2 = self.OnCreateElem(element.State,(120,0))
        elem2 = self.OnCreateElem(element.Boiler,(200,0))
	State3 = self.OnCreateElem(element.State,(200,100))
        elem3 = self.OnCreateElem(element.Turbine,(200,200))
	State4 = self.OnCreateElem(element.State,(120,200))
        elem4 = self.OnCreateElem(element.Condenser,(0,200))
	State1 = self.OnCreateElem(element.State,(0,100))
	
	"""
        elem1 = self.OnCreateElem(element.Transfo,(0,0))
	State1 = self.OnCreateElem(element.State,(120,0))
        elem2 = self.OnCreateElem(element.Transfo,(200,0))
	State2 = self.OnCreateElem(element.State,(200,100))
        elem3 = self.OnCreateElem(element.Transfo,(200,200))
	State3 = self.OnCreateElem(element.State,(120,200))
        elem4 = self.OnCreateElem(element.Transfo,(0,200))
	State4 = self.OnCreateElem(element.State,(0,100))
	"""

	
	elem1.connect(elem1.connection['O1'], State1, State1.connection['I1'])
	State1.connect(State1.connection['O1'],elem2, elem2.connection['I1'])
	elem2.connect(elem2.connection['O1'], State2, State2.connection['I1'])
	State2.connect(State2.connection['O1'],elem3, elem3.connection['I1'])
	elem3.connect(elem3.connection['O1'], State3, State3.connection['I1'])
	State3.connect(State3.connection['O1'],elem4, elem4.connection['I1'])
	elem4.connect(elem4.connection['O1'], State4, State4.connection['I1'])
	State4.connect(State4.connection['O1'],elem1, elem1.connection['I1'])


	"""
	#Test gauth:
	State4 = self.OnCreateElem(element.State,(0,100))
        elem1 = self.OnCreateElem(element.Transfo,(0,0))
	State1 = self.OnCreateElem(element.State,(120,0))
        elem2 = self.OnCreateElem(element.Transfo,(200,0))
	State2 = self.OnCreateElem(element.State,(200,100))

	State4.connect(State4.connection['O1'],elem1, elem1.connection['I1'])
	elem1.connect(elem1.connection['O1'], State1, State1.connection['I1'])
	State1.connect(State1.connection['O1'],elem2, elem2.connection['I1'])
	elem2.connect(elem2.connection['O1'], State2, State2.connection['I1'])
	"""

	self.doNotify()

    def OnConnect(self, event): # wxGlade: MyFrame.<event_handler>
	elem_a = self.project.elemList[self.combo_box_1.GetValue()]
	elem_b = self.project.elemList[self.combo_box_2.GetValue()]
	val_a = self.combo_box_3.GetValue()
	val_b = self.combo_box_4.GetValue()
	conn_a = elem_a.connection[val_a]
	conn_b = elem_b.connection[val_b]
	elem_a.connect(conn_a, elem_b, conn_b)

    def OnDeconnect(self, event): # wxGlade: MyFrame.<event_handler>
	elem_a = self.project.elemList[self.combo_box_1.GetValue()]
	elem_b = self.project.elemList[self.combo_box_2.GetValue()]
	val_a = self.combo_box_3.GetValue()
	conn_a = elem_a.connection[val_a]
	elem_a.connect(conn_a, elem_b, None)

    def OnClear(self, event): # wxGlade: MyFrame.<event_handler>
	self.project.clear()
	self.doNotify()
	self.combo_box_1.Clear()
	self.combo_box_2.Clear()
	self.combo_box_3.Clear()
	self.combo_box_4.Clear()
	
    def OnRefresh(self, event): # wxGlade: MyFrame.<event_handler>
	event.Skip()


    def OnCombo1(self, event): # wxGlade: MyFrame.<event_handler>
	self.combo_box_3.Clear()
	elemZ = self.project.elemList[self.combo_box_1.GetValue()]
	#print self.project.nameList

	for x in elemZ.connection:
		self.combo_box_3.Append(str(x))
		#print self.project.nameList[elemZ]
		#print 'link from', x,elemZ.connection[x],elemZ.connection[x].link,elemZ.connection[x].kind
	#print '++++++'

    def OnCombo2(self, event): # wxGlade: MyFrame.<event_handler>
	self.combo_box_4.Clear()
	elemZ = self.project.elemList[self.combo_box_2.GetValue()]
	#print '++++++'
	for x in elemZ.connection:
		self.combo_box_4.Append(x)
		#print self.project.nameList[elemZ]
		#print 'link from', x,elemZ.connection[x],elemZ.connection[x].link,elemZ.connection[x].kind
	#print '++++++'

    def OnCombo3(self, event): # wxGlade: MyFrame.<event_handler>
        event.Skip()

    def OnCombo4(self, event): # wxGlade: MyFrame.<event_handler>
        event.Skip()


    def OnRmElem(self, event): # wxGlade: MyFrame.<event_handler>
	# permet d'enlever un element
	name = str(self.combo_box_1.GetValue())
	self.project.removeElem(name)
	self.doNotify()


    def OnPropertyGrid(self, evt): # wxGlade: MyFrame.<event_handler>
        # affiche la property grid de l'element
	
	val = str(self.combo_box_1.GetValue())
	self.project.currentElem = self.project.elemList[val]

 	newframe = wx.Frame(parent = None, id = -1, title = val,size = (350,500),style = wx.CAPTION|wx.CLOSE_BOX|wx.SYSTEM_MENU|wx.RESIZE_BORDER|wx.FULL_REPAINT_ON_RESIZE|wx.CLIP_CHILDREN
)
	
	sizer_1 = wx.BoxSizer(wx.VERTICAL)
        grid_sizer_1 = wx.GridSizer(10, 1, 0, 0)
	for x in self.project.currentElem.properties:
		a = str(self.project.currentElem.properties[x].label)+':'+str(self.project.currentElem.properties[x].value)
		ctrl = wx.TextCtrl(newframe,-1,a,size=(300,100),style=wx.TE_PROCESS_ENTER)
        	grid_sizer_1.Add(ctrl, 0, 0, 0)
		ctrl.Bind(wx.EVT_TEXT_ENTER, self.OnCtrl)

	sizer_1.Add(grid_sizer_1, 1, wx.EXPAND, 0)
	newframe.SetSizer(sizer_1)
        sizer_1.Fit(newframe)
	newframe.Layout()
	newframe.Show()


    def OnCtrl(self, evt):
	val = evt.GetString()
	a=''
	for x in val:
		if x == ':':
			break
		a = a+x
	c = val.split(str(a)+':')
	b=c[1]
	self.project.currentElem.properties[a].impose(b)


# end of class MyFrame

    def OnNotif(self):
	self.combo_box_1.Clear()
	self.combo_box_2.Clear()
	self.combo_box_3.Clear()
	self.combo_box_4.Clear()
	
	for x in self.project.nameList:
		self.combo_box_1.Append(self.project.nameList[x]) 
		self.combo_box_2.Append(self.project.nameList[x]) 

	self.Refresh()	
	
